	
*********************************************************************
*
* Your line routine.
* Every time you are given: A0 : Chunky Screen (256x256x8)
*
* d0/d1  x1/y1
* d2/d3  x2/y2
* d4     colors
*
* other registers are in undefined state !!
* you may trash all regs except a7
*
*********************************************************************

	
_line
c

*************************************************************************
*									*	
* IRC #amycoders Fast!-Linedraw Compo 					*	
*									*
* Coded by Sniper 19.09.97 of Lightstorm Inc. & Lightforce	V1.5	*
*									*
* Speed: 55  on 1230 BlizzardIV 50Mhz 60ns Fastmem,Caches & Bursts on	*
* Size : 110 Bytes 							*
*									*
* Notes: I've splitted this in 2 parts, x & y interpolation. 		*
*	 Therefor it's very large,but fast (i believe).			*
*	 I cannot test it on an 68040/060.				*
* 	 I hope it's the fastest! ;)					*
*									*
*************************************************************************

	; calc xd,yd
	
	move	d2,d5
	move	d3,d6

	sub	d0,d5
	bpl.s	.isok
	neg	d5
.isok	sub	d1,d6	
	bpl.s	.isok1
	neg	d6
.isok1	
	; d5 = abs(deltax)
	; d6 = abs(deltay)

	; check xd<->yd
	cmp	d5,d6
	ble.s	interpolatey

**-**-**-**-**-**-**-**-**-**-**-**-**-**-**-**

interpolatex:
	subq    #1,d6
	ble.s	.exit					; zero or min than exit

	move.l	#256,d5					; calc yadder
	cmp	d3,d1					
	ble.s	.noneg
	neg.l	d5
.noneg	
	ext.l	d1
	asl.l	#8,d1					; * screenwidth
	add.l	d1,a0					; yoffs	

	ext.l	d0
	ext.l	d2
	sub.l	d0,d2					; delta x

	asl.l   #8,d2					; fk 8.8
	divs    d6,d2
	ext.l	d2					; long
	ror.l   #8,d2					; addx'er 

.innerlp 
    	move.b  d4,(a0,d0.w)				; save pixel
	addx.l  d2,d0					; add x8.8
	add.l	d5,a0					; y+yadder		
	dbra    d6,.innerlp
.exit	rts


**-**-**-**-**-**-**-**-**-**-**-**-**-**-**-**

interpolatey:
	subq	#1,d5
	ble.s	.exit

	moveq	#1,d6					; calc xadder
	cmp	d2,d0					
	ble.s	.noneg
	moveq	#-1,d6
.noneg		

	ext.l	d1
	ext.l	d3
	sub.l	d1,d3					; delta y
	
	asl.l	#8,d1					; * screenwidth
	asl.l  	#8,d3					; * screenwidth
	divs    d5,d3					; / xdelta
	
.innerlp 
	move.l	d1,d2					; yoffs*screenwidth
	move.b	d0,d2					; + xoffs
	move.b  d4,(a0,d2.l)				; save pixel 
	add	d3,d1					; add y8.8
	add	d6,d0					; x+xadder
	dbra    d5,.innerlp
.exit
	

**-**-**-**-**-**-**-**-**-**-**-**-**-**-**-**
d
	rts