chunkyline:
;
; Bresenham chunky line drawing routine by Stelios (c) 1997
; Special purpose for a fixed width&height of 256 at #amycoders competition
;
; > d0,d1,d2,d3.w = x0,y0,x1,y1
; >          d4.b = colour
; >          a0.l = chunky ptr
; ! d0-d3/d5-d6/a0
;
	moveq	#1,d6			;d6 = xdir
	sub.w	d0,d2			;d2 = dx
	bpl.s	.absdx
	neg.w	d2
	neg.l	d6
.absdx:	moveq	#1,d5
	lsl.w	#8,d5			;d5 = ydir
	sub.w	d1,d3			;d3 = dy
	bpl.s	.absdy
	neg.w	d3
	neg.l	d5
.absdy:	lsl.w	#8,d1
	ext.l	d0
	or.w	d1,d0
	add.l	d0,a0
	cmp.w	d2,d3			;swap (x,y) if dx<dy
	ble.s	.dxgdy
	exg	d2,d3			;d3 = incrE
	exg	d5,d6
.dxgdy:	move.w	d2,d0			;d0 = -incrN
	move.w	d2,d1
	lsr.w	#1,d1			;d1 = dx/2 (d)
.lp:	move.b	d4,(a0)
	sub.w	d3,d1			;d=d-incrE
	bpl.s	.dp
	add.w	d0,d1			;d=d-incrN
	add.l	d5,a0			;y=y+ydir
.dp:	add.l	d6,a0			;x=x+xdir
	dbf	d2,.lp
	rts
