*********************************************************************
*
* Your line routine.
* Every time you are given: A0.L : Chunky Screen (256x256x8)
*
* d0.w/d1.w  x1/y1
* d2.w/d3.w  x2/y2
* d4.b       color
*
* other registers are in undefined state !!
* you may trash all regs except a7
*
*********************************************************************

_line
c

;****************************************************************************
;**
;*       Size-optimized chunky linedraw routine, A
;*
;*  This is one of my contributions to #amycoders linedrawing-compo. This
;*  routine will participate size-optimizing competition. This code works
;*  with all 0x0 processors with any cache setup.
;*
;*  Code size without rts: 30 bytes.
;*  Average time (dec): -
;*
;*  Coded by Harry "Piru" Sintonen <sintonen@jyu.fi>.
;*  This code is copyright  1997 by Harry Sintonen, and was written 17th-
;*  19th september 1997.
;*
;*  Thanks must go to ArtDent for pointing some things out... :>
;*
;****************************************************************************
;*

;  IN: d0.w=x1, d1.w=y1, d2.w=x2, d3.w=y2, d4.b=color
;      a0=chunky buffer (256x256x8)
; OUT: line :) and d0-d3/d5-d6 trashed

	moveq	#0,d5		2	clear d5 upper word!
	moveq	#0,d6		2	init loop counter

	sub.w	d1,d3		2	dy=y2-y1
	lsl.w	#8,d1		2	ycnt=y1*256
	sub.w	d0,d2		2	dx=x2-x1

.loop	move.w	d1,d5		2
	move.b	d0,d5		2	offs = ycnt & FF00 ! xpos
	rol.w	#8,d0		2	get xcnt

	move.b	d4,0(a0,d5.l)	4	put pixel to offs (note .l)

	add.w	d2,d0		2	add dx to xcnt
	add.w	d3,d1		2	add dy to ycnt
	ror.w	#8,d0		2	get xpos of xcnt (xcnt/256)

	subq.b	#1,d6		2	loop 256 times
	bne.b	.loop		2
				;=30
d
	rts